local MSG = require "api_msg"
local CO = require "api_coservice"
local cjson = require "cjson"

local dset = {}
--------------------------------------
local function converR(gain)
	local present = ((tonumber(gain) + 17) * 100) /  ((6 + 17) * 100)
	return math.ceil( present * 200 )
end

local function API_get(red, args)
	local proxy = CO.GetProxy( "/ain", "codec" )
	if not proxy then
		MSG.ERROR( "codecError" )
		return true
	else
		local r, cfg = proxy.GetConfig()
		if r and cfg then
			MSG.OK("", {
				data = {
					gain = converR(cfg.gain or 0)
				}
			})
		else
			MSG.ERROR( "getAudioArgError" )
		end
		proxy:Destroy()
		return true
	end
end

--------------------------------------

local function conver(gain)
	gain = tonumber(gain)
	if gain == 199 then
		return 6
	end
	return (tonumber(gain) / 200) * (6 + 17) - 17
end

local function API_modify(red, args)
	if args and args.gain then
		local proxy = CO.GetProxy( "/ain", "codec" )
		if not proxy then
			MSG.ERROR( "codecError" )
			return true
		else
			local r = proxy.UpdateConfig( { gain = conver(args.gain) } )
			if r then
				MSG.OK("")
			else
				MSG.ERROR( "setAudioArgError" )
			end
			proxy:Destroy()
			return true
		end
	else
		MSG.ERROR( "argumentError" )
	end
	return true
end

--------------------------------------
dset.APIS = dset.APIS or {}

dset.APIS["get"] = API_get
dset.APIS["modify"] = API_modify

--------------------------------------
return dset

