local MSG = require "api_msg"
local CO = require "api_coservice"
local cjson = require "cjson"

local __flg, FEATURES = pcall( require, "features" )
if not __flg or type(FEATURES) ~= "table" then
	FEATURES = {
	}
end

local _M = {}

local function JSON_get(red, args)
	local info = {
		languageShow = not FEATURES.DISABLE_LANGUAGE,
		logoShow = not FEATURES.DISABLE_LOGO,
		loginImgShow = not FEATURES.DISABLE_LOGIN_IMG,
		--logoUrl = "static/img/logo.png",
		--logoUrl = "",
		languageOptions = {
		}
	}

	local mod_lang = require "api_lang"
	for _i, lang_opt in ipairs(mod_lang.support_langs) do
		table.insert(info.languageOptions, {
			value = lang_opt.value,
			name = lang_opt.name,
			url = "/lang/" .. lang_opt.value .. ".json"
		})
	end

	local set_default = false
	for _i, lang_opt in ipairs(info.languageOptions) do
		if lang_opt.value == FEATURES.DEFAULT_LANGUAGE then
			lang_opt.default = true
			set_default = true
			break
		end
	end
	
	--If not set, then set the first one as default.
	if not set_default and #info.languageOptions > 0 then
		info.languageOptions[1].default = true
	end

	MSG.OK( "", { data = info } )
	return true
end

_M.APIS = _M.APIS or {}
_M.APIS["get"] = JSON_get

return _M
