local MSG = require "api_msg"
local CO = require "api_coservice"
local cjson = require "cjson"

local __flg, FEATURES = pcall( require, "features" )
if not __flg or type(FEATURES) ~= "table" then
	FEATURES = {
	}
end

local _M = {}

local function JSON_nav(red, args)
	local nav = {
		main_nav = {
			home = true,
			sip_GB = (FEATURES.FEATURE_SIP or FEATURES.FEATURE_GB28181) and true or false,
			flowservice = FEATURES.FEATURE_STREAMER and true or false,
			networksetup = true,
			recordManage =  FEATURES.FEATURE_RECORD and true or false,
			picManage = true,
			lineGain = false,
			discoveryServer = FEATURES.FEATURE_NDI_DISCOVERY and true or false,
			previewConfig = true
		},

		sys_nav = {
			platform = FEATURES.FEATURE_IMS_CONNECTION and true or false,
			users = true,
			["system-time"] = true,
			reset = true,
			reboot = true,
			restore = true,
			firmwareudp = true,
			terminal = false
		}
	}

	MSG.OK( "", { data = nav } )
	return true
end

_M.APIS = _M.APIS or {}
_M.APIS["nav"] = JSON_nav

return _M
