
local CO = require "api_coservice"
local MSG = require "api_msg"
local cjson = require "cjson"

local dset = {}

--设置编码参数

local function API_set(red,args)
    if not args then
        MSG.ERROR( "argumentError" )
        return true
    end
	--[[
    if tonumber(args.GOPSize) == 0 then
		args.GOPSize = args.customGOPSize
	end
	if tonumber(args.Bitrate) == 0 then
		args.Bitrate = args.customBitrate
	end
	
	if args.FrameRate == "custom" then
		args.FrameRate = args.customFrameRate
	end 
	--]]
	
    --output  给输出做编码设置  音频参数： 有/无
    --id  给本地视频源做编码设置   音频参数： 无/数字/模拟
    local tabs = {}

    tabs.RefFrame=args.RefFrame 
    tabs.GOPSize=args.GOPSize
    tabs.BRCtrl=args.BRCtrl
    tabs.Chrome=args.Chrome
    tabs.AudioSource=args.AudioSource
    tabs.Profile=args.Profile
    tabs.Bitrate=args.Bitrate
    tabs.Scaling=args.Scaling
    tabs.FrameRate=args.FrameRate
    tabs.FrameRateMode=args.FrameRateMode

    ---TODO 注意proxy的对象
    if args.output then
        --设置海思输出的编码设置
        local proxy = CO.GetProxy( "/encoder", "codec" )
        if not proxy then
            MSG.ERROR( "codecError" )
        else
            local output
            if tonumber(args.output) ==1 then
                output = "OUTPUT1"
            else
                output = "OUTPUT2"
            end
			if args.mode and args.mode ~= "" and args.mode ~= "0" and args.mode ~= "00" then
				output = output .. ":sub"
			end

            local r, data,err = proxy.SetEncoder(output,tabs)
			proxy:Destroy()
            if not r or not data then
                MSG.ERROR( "setCodecArgError" )
            else
                MSG.OK()
            end
        end
    else
        --设置amba视频源的编码设置
        if not args.sourceId then
            MSG.ERROR( "argumentError" )
            return true
        end

		local location = args.sourceId
		if location:match(":sub$") then
			location = location:match("(.*):sub$")
			if not args.mode or args.mode == "" then
				args.mode = "01"
			end
		else
			if not args.mode or args.mode == "" then
				args.mode = "00"
			end
		end

        local proxy = CO.GetProxy( "/encoder", "codec", location)
        if not proxy then
            MSG.ERROR( "codecError" )
            return true
        end
		--NOTE: "00"为主码流，"01"为子码流，"02"为MJPEG码流
        -- local r, rr, err = proxy.SetEncoder("00", tabs) 
        local r, rr, err = proxy.SetEncoder(args.mode, tabs) 

        proxy:Destroy()

		--选择音频源 NOTE by 左振宇
		if args.AudioSource then
        	proxy = CO.GetProxy( "/encoder", "codec" )
        	if not proxy then
				r = false
				rr = false
            else
                r, rr, err = proxy.SelectAudioSource(location .. (args.mode == "01" and ":sub" or ""), args.AudioSource)
				proxy:Destroy()
        	end
		end

        if r and rr then
            MSG.OK("")
        else
            MSG.ERROR( "setCodecArgError" )
        end
    end
    return true
end

--查询编码参数
local function API_get(red, args)
    ---TODO 注意proxy的对象
    if args.output then
    --海思输出的编码设置
        local proxy = CO.GetProxy( "/encoder", "codec" )
        if not proxy then
            MSG.ERROR( "codecError" )
        else
            local output
            if tonumber(args.output) ==1 then
                output = "OUTPUT1"
            else
                output = "OUTPUT2"
            end

			if args.mode and args.mode ~= "" and args.mode ~= "0" and args.mode ~= "00" then
				output = output .. ":sub"
			end

            local r, data,err = proxy.GetEncoder(output)
			proxy:Destroy()
            if not r or not data then
                MSG.ERROR( "getCodecArgError" )
            else
                MSG.OK("",{data=data})
            end
        end
        return true
    else
        --查询本地amba编码模块的编码设置
        if not args.sourceId then
            MSG.ERROR( "argumentError" )
            return true
        end

		local location = args.sourceId
		if location:match(":sub$") then
			location = location:match("(.*):sub$")
			if not args.mode or args.mode == "" then
				args.mode = "01"
			end
		else
			if not args.mode or args.mode == "" then
				args.mode = "00"
			end
		end

        local proxy = CO.GetProxy( "/encoder", "codec", location )
        if not proxy then
            MSG.ERROR( "codecError" )
            return true
        end

		--NOTE: "00"为主码流，"01"为子码流，"02"为MJPEG码流
        local r,configs,err = proxy.GetEncoder(args.mode)
        proxy:Destroy()

        if not r or not configs then
            MSG.ERROR( "getVideoArgError" )
            return true
        end

		proxy = CO.GetProxy( "/encoder", "codec" )
		if proxy then
			local src
			r, src = proxy.GetAudioSource( location .. (args.mode == "01" and ":sub" or "") )
			proxy:Destroy()
			if r then
				configs.AudioSource = src
			end
		end

        MSG.OK( "", {
        data = configs
        })
        return true
    end
    return true
end

----------------------
dset.APIS = dset.APIS or {}

dset.APIS["get"] = API_get
dset.APIS["modify"] = API_set

--------------------------------------
return dset
