local MSG = require "api_msg"
local CO = require "api_coservice"
local cjson = require "cjson"
local __flg, FEATURES = pcall( require, "features" )
if not __flg or type(FEATURES) ~= "table" then
	FEATURES = {
	}
end
local 	PRODUCT_INFO = require "patch_product"

local upload = require "resty.upload"
os.execute("chmod 777 -R  /data/web/html/static")
STORE_PATH = "/data/web/html/static/img/"

local dset = {}

if PRODUCT_INFO and  type(PRODUCT_INFO) == "table" and PRODUCT_INFO.name then
	dset.data = PRODUCT_INFO
else
	dset.data = {
					name = (FEATURES.DEVICE_TYPE == "E_DOCTOR_S" and "翼多示教终端" or "Decoder"),
					loginImg = "",
					logoUrl = "",
					copyright = "Decoder",
					serialNumber = "000000000"
				}
end

local function API_get(red, args)
	if FEATURES.FEATURE_LOCAL_STREAM then
		local proxy = CO.GetProxy( "/", "CoManager" )
		if proxy then
			local r, name,sn = proxy.link_sysinfo()

			proxy:Destroy()
			if r and name then
				dset.data.name = name
				dset.data.serialNumber = sn             
				MSG.OK( "", { data = dset.data})
				return true
			else
				return false, "getSerialNOError"
			end
		else
			return false, "codecError" 
		end
	else
		local proxy = CO.GetProxy( "/", "systemctrl" )
		if  proxy then
			local r, sn = proxy.GetSerialNo()
			proxy:Destroy()
			if r and sn then
				dset.data.serialNumber = sn
			end
		end
		MSG.OK( "", { data = dset.data})
	end

	return true
end


local function checkPartType(res)
	if type(res) == "table" then
		local idr = res[1]:lower()
		if idr == "content-disposition" then
			local fieldname, filename = res[2]:match('name=%"(.*)%".*filename=%"(.*)%"')
			if not fieldname then
				fieldname = res[2]:match('name=%"(.*)%"')
			end
			if not fieldname then
				return nil
			end
			if not filename then
				return "field", fieldname
			else
				return "file", fieldname, filename
			end
		elseif idr == "content-type" then
			return idr, res[2] or ""
		else
			return nil
		end
	else
		return nil
	end
end


local function updateInfo(serialNumber,name)
	if not serialNumber or not name then
		MSG.ERROR( "无效的参数" )
	else
		local proxy = CO.GetProxy( "/", "systemctrl" )
		if proxy then
			local r, done = proxy.CreateSerialNo(serialNumber)
			proxy:Destroy()
			if r and done then
				dset.data.name = name
				dset.data.serialNumber = serialNumber
				return true
			else
				return false, "setSerialNOError"
			end
		else
			return false, "systemError" 
		end
	end
	return true
end

--getUploadFile in api_firmware.lua
local function API_upgrade(red, args)

	local done ,err = updateInfo(args.serialNumber,args.name)
	if not done then
		MSG.ERROR( err )
	end
	MSG.OK()
	return true
end

--------------

dset.APIS = dset.APIS or {}

dset.APIS["get"] = API_get
dset.APIS["upgrade"] = API_upgrade

return dset

