
local CO = require "api_coservice"
local MSG = require "api_msg"
local cjson = require "cjson"

local dset = {}

local function API_set(red,args)
    if not args or (not args.sourceId and not args.output) or not args.id then
        MSG.ERROR( "argumentError" )
        return true
    end
	local proxy
	local chl 
	--叠加编码器上OSD
	if args.sourceId then
		proxy = CO.GetProxy( "/osd", "codec",args.sourceId )
		chl = "00" 
	elseif args.output then --叠加解码器输出上OSD
		proxy = CO.GetProxy( "/osd", "OSD" )
		chl = args.output
	end

    if not proxy then
        MSG.ERROR( "codecError" )
        return true
    else
        local tabs={}
        tabs.x = args.x
        tabs.bold = args.bold
        tabs.type = args.type
        tabs.font = args.font
        tabs.position = args.position
        tabs.id = args.id
		tabs.text = args.text
		--tabs.imgname = args.imgname
		tabs.color = args.color
		tabs.y = args.y
		tabs.size = args.size
		tabs.outline = args.outline
		tabs.outlineColor = args.outlineColor

		--NOTE: "00"为主码流，"01"为子码流，"02"为MJPEG码流 output 为解码器输出
        local r,done,err = proxy.SetOsd(chl, tabs)
        proxy:Destroy()

        if not r or not done then
            MSG.ERROR( "setOSDError" )
        else
            MSG.OK()
        end
	end
	return true
end

local function API_get(red, args)
    if not args or (not args.sourceId and not args.output) then
        MSG.ERROR( "argumentError" )
        return true
    end

	local proxy
	local chl 
	--叠加编码器上OSD
	if args.sourceId then
		proxy = CO.GetProxy( "/osd", "codec",args.sourceId )
		chl = "00" 
	elseif args.output then --叠加解码器输出上OSD
		proxy = CO.GetProxy( "/osd", "OSD" )
		chl = args.output
	end

    if not proxy then
        MSG.ERROR( "codecError" )
        return true
    else
		--NOTE: "00"为主码流，"01"为子码流，"02"为MJPEG码流
        local r,fmtCfg,err = proxy.GetOsd(chl)
        proxy:Destroy()

        if not r or not fmtCfg then
            MSG.ERROR( "getOSDError" )
        else
			MSG.OK( "", { data = fmtCfg } )
        end
	end
	return true
end

local function API_GetWordSize(red, args)
    if not args or (not args.sourceId and not args.output) then
        MSG.ERROR( "argumentError" )
        return true
    end

    local proxy
	local chl
    if args.sourceId then
        proxy = CO.GetProxy( "/osd", "codec", args.sourceId )
        chl = "00"
    elseif args.output then --叠加解码器输出上OSD
        proxy = CO.GetProxy( "/osd", "OSD" )
        chl = args.output
    end

    if not proxy then
        MSG.ERROR( "codecError" )
        return true
    else
		--NOTE: "00"为主码流，"01"为子码流，"02"为MJPEG码流
        local r,cfg,err = proxy.GetOsdSetting(chl)
        proxy:Destroy()

        if not r or not cfg then
            MSG.ERROR( "getOSDError" )
        else
			MSG.OK( "", { data = cfg } )
        end
	end
	return true
end

local function API_ModifyWordSize(red, args)
    if not args or (not args.sourceId and not args.output) then
        MSG.ERROR( "argumentError" )
        return true
	end

	local proxy
	local chl
    if args.sourceId then
        proxy = CO.GetProxy( "/osd", "codec", args.sourceId )
        chl = "00"
    elseif args.output then --叠加解码器输出上OSD
        proxy = CO.GetProxy( "/osd", "OSD" )
        chl = args.output
    end

    if not proxy then
        MSG.ERROR( "codecError" )
        return true
    else
		--NOTE: "00"为主码流，"01"为子码流，"02"为MJPEG码流
        local r,done,err = proxy.SetOsdSetting(chl, args)
        proxy:Destroy()

        if not r or not done then
            MSG.ERROR( "modifyOSDError" )
        else
			MSG.OK()
        end
	end
	return true
end

----------------------
dset.APIS = dset.APIS or {}

dset.APIS["get"] = API_get
dset.APIS["modify"] = API_set
dset.APIS["GetWordSize"] = API_GetWordSize
dset.APIS["ModifyWordSize"] = API_ModifyWordSize

--------------------------------------
return dset

