
local CO = require "api_coservice"
local MSG = require "api_msg"
local cjson = require "cjson"

local dset = {}


-- 添加自定义分屏模式的模板---数据无需改动
local function API_template(red, args)
    local Data =[[
        [{
            "conflict": 0,
            "name": "picInPic",
            "position": [{
              "y": 0,
              "x": 0,
              "height": 100,
              "width": 100
            }, {
              "y": 69,
              "x": 69,
              "height": 30,
              "width": 30
            }],
            "id": 1
          }, {
            "conflict": 1,
            "name": "oneScreen",
            "position": [{
              "y": 0,
              "x": 0,
              "height": 100,
              "width": 100
            }],
            "id": 2
          }, {
            "conflict": 1,
            "name": "twoScreen",
            "position": [{
              "y": 25,
              "x": 0,
              "height": 50,
              "width": 50
            }, {
              "y": 25,
              "x": 50,
              "height": 50,
              "width": 50
            }],
            "id": 3
          }, {
            "conflict": 1,
            "name": "threeScreen",
            "position": [{
              "y": 25,
              "x": 0,
              "height": 50,
              "width": 50
            }, {
              "y": 0,
              "x": 50,
              "height": 50,
              "width": 50
            }, {
              "y": 50,
              "x": 50,
              "height": 50,
              "width": 50
            }],
            "id": 4
          }, {
            "conflict": 1,
            "name": "fourScreen",
            "position": [{
              "y": 0,
              "x": 0,
              "height": 50,
              "width": 50
            }, {
              "y": 0,
              "x": 50,
              "height": 50,
              "width": 50
            }, {
              "y": 50,
              "x": 0,
              "height": 50,
              "width": 50
            }, {
              "y": 50,
              "x": 50,
              "height": 50,
              "width": 50
            }],
            "id": 5
          }, {
            "conflict": 1,
            "name": "fiveScreen",
            "position": [{
              "y": 0,
              "x": 0,
              "height": 50,
              "width": 50
            }, {
              "y": 50,
              "x": 0,
              "height": 50,
              "width": 50
            }, {
              "y": 0,
              "x": 50,
              "height": 33.33,
              "width": 50
            }, {
              "y": 33.33,
              "x": 50,
              "height": 33.33,
              "width": 50
            }, {
              "y": 66.66,
              "x": 50,
              "height": 33.33,
              "width": 50
            }],
            "id": 6
          }, {
            "conflict": 1,
            "name": "sixScreen",
            "position": [{
              "y": 0,
              "x": 0,
              "height": 66.66,
              "width": 66.66
            }, {
              "y": 0,
              "x": 66.66,
              "height": 33.33,
              "width": 33.33
            }, {
              "y": 33.33,
              "x": 66.66,
              "height": 33.33,
              "width": 33.33
            }, {
              "y": 66.66,
              "x": 0,
              "height": 33.33,
              "width": 33.33
            }, {
              "y": 66.66,
              "x": 33.33,
              "height": 33.33,
              "width": 33.33
            }, {
              "y": 66.66,
              "x": 66.66,
              "height": 33.33,
              "width": 33.33
            }],
            "id": 7
          }, {
            "conflict": 1,
            "name": "sevenScreen",
            "position": [{
              "y": 0,
              "x": 0,
              "height": 66.66,
              "width": 66.66
            }, {
              "y": 0,
              "x": 66.66,
              "height": 33.33,
              "width": 33.33
            }, {
              "y": 33.33,
              "x": 66.66,
              "height": 33.33,
              "width": 33.33
            }, {
              "y": 66.66,
              "x": 0,
              "height": 33.33,
              "width": 25
            }, {
              "y": 66.66,
              "x": 25,
              "height": 33.33,
              "width": 25
            }, {
              "y": 66.66,
              "x": 50,
              "height": 33.33,
              "width": 25
            }, {
              "y": 66.66,
              "x": 75,
              "height": 33.33,
              "width": 25
            }],
            "id": 8
          }, {
            "conflict": 1,
            "name": "eightScreen",
            "position": [{
              "y": 0,
              "x": 16.66,
              "height": 33.33,
              "width": 33.33
            }, {
              "y": 0,
              "x": 50,
              "height": 33.33,
              "width": 33.33
            }, {
              "y": 33.33,
              "x": 0,
              "height": 33.33,
              "width": 33.33
            }, {
              "y": 33.33,
              "x": 33.33,
              "height": 33.33,
              "width": 33.33
            }, {
              "y": 33.33,
              "x": 66.66,
              "height": 33.33,
              "width": 33.33
            }, {
              "y": 66.66,
              "x": 0,
              "height": 33.33,
              "width": 33.33
            }, {
              "y": 66.66,
              "x": 33.33,
              "height": 33.33,
              "width": 33.33
            }, {
              "y": 66.66,
              "x": 66.66,
              "height": 33.33,
              "width": 33.33
            }],
            "id": 9
          }, {
            "conflict": 1,
            "name": "nineScreen",
            "position": [{
              "y": 0,
              "x": 0,
              "height": 33.33,
              "width": 33.33
            }, {
              "y": 0,
              "x": 33.33,
              "height": 33.33,
              "width": 33.33
            }, {
              "y": 0,
              "x": 66.66,
              "height": 33.33,
              "width": 33.33
            }, {
              "y": 33.33,
              "x": 0,
              "height": 33.33,
              "width": 33.33
            }, {
              "y": 33.33,
              "x": 33.33,
              "height": 33.33,
              "width": 33.33
            }, {
              "y": 33.33,
              "x": 66.66,
              "height": 33.33,
              "width": 33.33
            }, {
              "y": 66.66,
              "x": 0,
              "height": 33.33,
              "width": 33.33
            }, {
              "y": 66.66,
              "x": 33.33,
              "height": 33.33,
              "width": 33.33
            }, {
              "y": 66.66,
              "x": 66.66,
              "height": 33.33,
              "width": 33.33
            }],
            "id": 10
          }]
    ]]
    MSG.OK("",{
        data=cjson.decode(Data),
        code = 0,
        count = 1000,
    })
    return true
end


--------------------------------------------------------todo-------------------------------------
local function API_add(red,args)
  if not args.name or not args.data  then
    MSG.ERROR( "argumentError" )
    return true
  end
  local proxy = CO.GetProxy( "/layout", "codec" )
  if not proxy then
    MSG.ERROR( "systemError" )
    return true
    else
        local tabs = {}
        tabs.name=args.name
        tabs.number=#args.data
        tabs.position=args.data
        tabs.img_id = tonumber(args.img_id or 0)
        local r,done,err = proxy.AddLayout(tabs)
    if not r or not done then
      MSG.ERROR( "addLayoutError",err )
    else
      MSG.OK( "" )
    end
  end
  return true
end


local function ModifyPic(output,img_id)
    ngx.log(ngx.ALERT, "--ModifyPic---------",output,img_id)
    local proxy_img = CO.GetProxy( "/pics", "picManager", "local",10)
    if proxy_img then
        MSG.OK("")
        ngx.eof()
        local tab={}
        tab.output = output
        tab.id = img_id
        tab.type = "bg"
        tab.enable = 1
        local r, done = proxy_img.ModifyPic(tab)
        proxy_img:Destroy()
    else
        return false
    end
    return true
end
local function API_modify(red,args)
    if not args.id then
		MSG.ERROR( "argumentError" )
		return true
  	end
    local proxy = CO.GetProxy( "/layout", "codec" )
  	if not proxy then
		MSG.ERROR( "systemError" )
		return true
    else
        local tabs = {}
        tabs.name=args.name
        tabs.number=#args.data
        tabs.enable=args.enable
        tabs.position=args.data
        tabs.img_id = tonumber(args.img_id or 0)
        local r,done,err= proxy.ChangeLayout(args.id,tabs)
        proxy:Destroy()
		if not r or not done then
			MSG.ERROR( "modifyLayoutError",err )
		else
			--ngx.log(ngx.ALERT, "--判断当前分屏是否正在被输出使用---------")
			--判断当前分屏是否正在被输出使用
			for i=0,1 do
				local proxy = CO.GetProxy( "/output/hd"..i, "codec" )
				if  proxy then
					local r, status = proxy.GetStatus(i)
					if  status and status.layout then
						--ngx.log(ngx.ALERT, "--id----",status.layout,args.id)
						if tonumber(status.layout) == tonumber(args.id) then
							--ngx.log(ngx.ALERT, "--ModifyPic----")
							ModifyPic(i+1,tabs.img_id)
							proxy.SetOutputLayout( args.id )
						end
					end
					proxy:Destroy()
				end
			end
			MSG.OK( "" )
		end
  	end

    return true
end


local function API_remove(red,args)
    if not args or not args.id  then
        MSG.ERROR( "argumentError" )
        return true
    end
	
	for i=0,1 do
		local proxy = CO.GetProxy( "/output/hd"..i, "codec" )
		if  proxy then
			local r, layoutID = proxy.GetOutputLayoutID(i)
			if  r and layoutID then
				if tonumber(layoutID) == tonumber(args.id) then
					MSG.ERROR( "delUseLayoutError")
					proxy:Destroy()
					return true
				end
			end
			proxy:Destroy()
		end
	end

    local proxy = CO.GetProxy( "/layout", "codec" )
  	if not proxy then
    MSG.ERROR( "systemError" )
    return true
  else
        local r,done,err = proxy.RemoveLayout(args.id)

    if not r or not done then
      MSG.ERROR( "delLayoutError",err )
    else
      MSG.OK( "" )
    end
  end

    return true
end



----------------------
dset.APIS = dset.APIS or {}

dset.APIS["add"] = API_add
dset.APIS["modify"] = API_modify
dset.APIS["remove"] = API_remove
dset.APIS["template"] = API_template

--------------------------------------
return dset
