local CO = require "api_coservice"
local MSG = require "api_msg"
local cjson = require "cjson"
pcall( require, "features" )

local dset = {}
--------------------------------------
local function API_get(red, args)
	if _G.FEATURE_WORK == "master" then
		MSG.OK( "", {
			data = {
				mode = "master",
				address = "",
				port = 0
			}
		})
		return true
	end

	local proxy = CO.GetProxy( "/CO_ENV", "coserver", "local", 3, "unix:/var/run/coaf.coserver.ctrl" )
	if not proxy then
		MSG.ERROR( "coEnvError" )
	else
		local addr, port = proxy._P( "MASTER_ADDR", "MASTER_PORT" )
		proxy:Destroy()
		if addr then
			MSG.OK( "", {
				data = {
					address = addr,
					addr_port = port or 14000
				}
			})
		else
			MSG.ERROR( "getMAddrError" )
		end
	end
	return true
end

local function API_set(red, args)
	if _G.FEATURE_WORK == "master" then
		MSG.OK()
		return true
	end

	if not args or not args.address then
		MSG.ERROR( "argumentError" )
		return true
	end

	local proxy = CO.GetProxy( "/CO_ENV", "coserver", "local", 3, "unix:/var/run/coaf.coserver.ctrl" )
	if not proxy then
		MSG.ERROR( "coEnvError" )
	else
		local r, done = proxy:P_SET({ MASTER_ADDR = args.address, MASTER_PORT = tonumber(args.addr_port)})
		proxy:Destroy()
		if r and done then
			MSG.OK()
		else
			-- MSG.ERROR( "设置平台地址失败！错误：" .. (done or "未知") )
			MSG.ERROR("setMAddrError")
		end
	end
	return true
end


--------------------------------------
dset.APIS = dset.APIS or {}

dset.APIS["set"] = API_set
dset.APIS["get"] = API_get

--------------------------------------
return dset

