local MSG = require "api_msg"
local CO = require "api_coservice"
local cjson = require "cjson"
local _dbg = require "coaf.debug"

local dset = {}
--------------------------------------

local function API_player_get_status(red, args)
	local proxy = CO.GetProxy( "/streams", "codec" )
	if not proxy then
		MSG.ERROR( "systemError" )
		return true
	else
		local out = tonumber(args.output)
		if not out then
			MSG.ERROR("Args Error")
			return true
		end
		out = out -1
		local r, streams = proxy.GetLiveStatusList(out)
		proxy:Destroy()

		if not r or not streams then
			MSG.ERROR( "getStreamsError" )
			return true
		end
	
		local result = {
		}

		--ngx.log(ngx.ERR, string.format("len = %d", #streams))
		for i=1, #streams do
			ngx.log(ngx.ERR, string.format("prepare to add %s", streams[i].id))
			local _, name = streams[i].file_name:match("(.+)%/(.+)")
			local item = {
				id = streams[i].id,
				current_name = name,
				current_time = tonumber(streams[i].live_position),
				total_time = tonumber(streams[i].file_duration),
				current_num = streams[i].current_num,
				total_num = streams[i].total_num,
				play = streams[i].play,
				layout_number = streams[i].layout_number
			}
			table.insert( result, item )
		end

		MSG.OK( "", {
			data = result
		})
		return true
	end
end

local function API_player_control(red, args)
	if args and args.id and args.output  and args.control then
		local proxy = CO.GetProxy( "/streams", "codec" )
		if not proxy then
			MSG.ERROR( "systemError" )
			return true
		else
			local r, done, err = proxy.PlayerControl(args.output, args.id, args.control, args.current_time)
			if not r or not done then
				MSG.ERROR( "PlayerControl Error" )
			else
				MSG.OK()
			end
			proxy:Destroy()
			return true
		end
	
	else
		MSG.ERROR( "argumentError" )
	end
	return true
end

--------------------------------------

--------------------------------------
dset.APIS = dset.APIS or {}
dset.APIS["player_control"] = API_player_control
dset.APIS["player_get_status"]   = API_player_get_status

--------------------------------------
return dset

