local MSG = require "api_msg"
local CO = require "api_coservice"
local cjson = require "cjson"
local _dbg = require "coaf.debug"

local dset = {}

local _M = {
    preview_mode = 1,
    audio = 0
}

local function API_get()
    MSG.OK("", {data = {
        mode=_M.preview_mode
    }})
    return true
end

local function API_modify(red, args)
    if not args or not args.mode then
		MSG.ERROR( "argumentError" )
		return true
	end
    _M.preview_mode = args.mode
    MSG.OK("")
    return true
end


local function API_getAudio()
    MSG.OK("", {data = {
        audio = _M.audio
    }})
    return true
end

local function API_modifyAudio(red, args)
    if not args or not args.audio then
		MSG.ERROR( "argumentError" )
		return true
	end
    _M.audio = args.audio
    MSG.OK("")
    return true
end

dset.APIS = dset.APIS or {}

dset.APIS["get"] = API_get
dset.APIS["modify"] = API_modify
dset.APIS["getAudio"] = API_getAudio
dset.APIS["modifyAudio"] = API_modifyAudio

return dset