
local CO = require "api_coservice"
local MSG = require "api_msg"
local cjson = require "cjson"

local dset = {}
------------------------------------------------ 前置裁切

local function API_set(red,args)
    if not args or not args.sourceId then
        MSG.ERROR( "argumentError" )
        return true
    end

    local proxy = CO.GetProxy( "/config/avio", "codec", args.sourceId )
    if not proxy then
        MSG.ERROR( "codecError" )
        return true
    else
        local params = {
            ["video.brightness"] = args.brightness,
            ["video.contrast"] = args.contrast,
            ["video.saturation"] = args.saturation,
            ["video.hue"] = args.hue,
        }

        local r,done,err = proxy:P_SET(params)
        proxy:Destroy()

        if not r or not done then
            MSG.ERROR( "setVideoColorError" )
        else
            MSG.OK()
        end
    end
    return true
end

local function API_get(red, args)
	if not args or not args.sourceId then
		MSG.ERROR( "argumentError" )
        return true
	end
    local proxy = CO.GetProxy( "/config/avio", "codec", args.sourceId )
    if not proxy then
        MSG.ERROR( "codecError" )
        return true
    else
        local r,data,err = proxy:P_GET("video")
        proxy:Destroy()

        if not r or not data then
            MSG.ERROR( "getVideoColorError" )            
        else
            MSG.OK("",{data={
                brightness = data.brightness or 128,
                contrast = data.contrast or 128,
                saturation = data.saturation or 128,
                hue = data.hue or 128,
            }        
        })
        end
    end
    return true
end

----------------------
dset.APIS = dset.APIS or {}

dset.APIS["vsource_get"] = API_get
dset.APIS["vsource_set"] = API_set

--------------------------------------
return dset

