local coaf = require "coaf.core"
local _dbg = require "coaf.debug"

local DEFAULT_DELAY = 50

local _M = {
	support_max_tap_mixers = 16
}

function _M.CheckTypeAndArgs(module_type, args)
	return module_type, args
end

function _M.CheckMixerConnection( tap_name, mixer_name )
	return true
end

function _M.ReleaseMixerConnection( tap_name, mixer_name )
end

function _M.CreateMixer(name, module_type, args)
	if not name then
		_dbg.Error( "DMIX", "Invalid mixer name while creating mixer!" )
		return nil
	end

	if _M.MixerExists(name) then
		return name
	else
		_dbg.Error( "DMIX", "ALSA not configured dmixer of", name )
		return nil
	end
end

function _M.CreateChannelIndivMixer(base_mixer_name, channel_name, suggest_mixer_name, args)
	--Not support.
	return false, nil, nil
end

function _M.GetChannelIndivMixerSourceTypeAndArgs(mixer_name, tableFmt)
	--Not support.
	return nil
end

function _M.RemoveChannelIndivMixer( base_mixer_name, channel_name, mixer_name )
	--Not support.
end

function _M.GetMixerSourceTypeAndArgs(mixer_name)
	return "ALSA", { device = "capture_" .. mixer_name }
end

function _M.GetMixerSinkTypeAndArgs(mixer_name)
	return "ALSA", { 
		device = "mixer_" .. mixer_name, 
		buffer = DEFAULT_DELAY, 
		fixed_sampling=48000, --The DMIX is fixed sampling, so can't 
		fixed_channels=2 
	}
end

function _M.RemoveMixer(name)
	if not name then
		_dbg.Error( "DMIX", "Invalid mixer name while removing mixer!" )
		return nil
	end

	--TODO:
	return true
end

function _M.GetMixers()
	--TODO:
end

function _M.MixerExists(name)
	--TODO:
	return name
end

return _M


