local coaf = require "coaf.core"
local _dbg = require "coaf.debug"

local _M = {
	support_max_tap_mixers = 0,
	created_mixers = {
	},

	mixer_connections = {
	}
}

function _M.CheckTypeAndArgs(module_type, args)
	return module_type, args
end

function _M.CheckMixerConnection( tap_name, mixer_name )
	if not tap_name or not mixer_name then
		return false
	end
	if not _M.created_mixers[mixer_name] then
		return false
	end
	if _M.mixer_connections[mixer_name] then
		return false
	else
		_M.mixer_connections[mixer_name] = tap_name
		return true, "#LOOP-DIRECTLY#"
	end
end

function _M.ReleaseMixerConnection( tap_name, mixer_name )
	if not tap_name or not mixer_name then
		return
	end
	if not _M.created_mixers[mixer_name] then
		return
	end
	if _M.mixer_connections[mixer_name] ~= tap_name then
		return
	else
		_M.mixer_connections[mixer_name] = nil
	end
end

function _M.CreateMixer(name, module_type, args)
	if not name then
		_dbg.Error( "NONE-MIXER", "Invalid mixer name while creating mixer!" )
		return nil
	end

	if _M.created_mixers[name] then
		return name
	end

	_M.created_mixers[name] = name
	return name
end

function _M.CreateChannelIndivMixer(base_mixer_name, channel_name, suggest_mixer_name, args)
	return false, nil, nil
end

function _M.GetChannelIndivMixerSourceTypeAndArgs(mixer_name, tableFmt)
	--TODO:
	return nil
end

function _M.RemoveChannelIndivMixer( base_mixer_name, channel_name, mixer_name )
	return false
end

function _M.GetMixerSourceTypeAndArgs(mixer_name)
	return nil
end

function _M.GetMixerSinkTypeAndArgs(mixer_name)
	return "#LOOP-DIRECTLY#", nil
end

function _M.RemoveMixer(name)
	if not name then
		_dbg.Error( "NONE-MIXER", "Invalid mixer name while removing mixer!" )
		return nil
	end

	_M.created_mixers[name] = nil
	return true
end

function _M.GetMixers()
	local rslt = {}
	--local k,v
	for k,v in pairs(_M.created_mixers) do
		table.insert( rslt, { id=v, mo_type="default", name=k } )
	end
	return rslt
end

function _M.MixerExists(name)
	if not name then
		return nil
	else
		return _M.created_mixers[name], "default"
	end
end

return _M


