local DC = require "supertable.declare"
local CONF = require "supertable.core"

local _M = {
	config_file = "/data/configs/discovery.conf"
}

--------------------------------------------

local disco_template = DC.OBJ({
	ndi = DC.OBJ({
		manuals = DC.ARR( DC.STR("") ),
		groups = DC.ARR( DC.STR("") ),
		--Use NDI discovery_server funtion, add by kiloview@2020-9-28
		use_discovery_server = DC.BOOL(false),
		discovery_server = DC.STR(""),
	})
	--TODO: Other discovery types.
}) : __changed( function(conf)
	conf:TAB_SAVE()
end)

local fail_default = {}
--------------------------------------------

function _M.Load()
	local conf = CONF.Create({}, disco_template)
	conf:TAB_STORAGE( "file", { file = _M.config_file } )
	local _, r = conf:TAB_LOAD()
	if not r then
		conf:TAB_BIND(fail_default or {})
		conf:TAB_SAVE()
	end
	conf:TAB_RESET_CHANGE()
	return conf
end

--------------------------------------------

return _M
