--[[
Description:
Author:
Date: 2021-03-04 08:07:59
LastEditTime: 2021-03-08 09:17:27
LastEditors:
--]]
local DC = require "supertable.declare"
local CONF = require "supertable.core"

local _M = {
	config_file = "/data/configs/layouts.conf"
}

--------------------------------------------

local layout_template = DC.SET(
	DC.OBJ{
		id = DC.INT(1),
		name = DC.STR("oneScreen"),
		number = DC.INT(1),
		enable = DC.INT(0),
		position = DC.ARR(
			DC.OBJ{
				x = DC.INT(0),
				y = DC.INT(0),
				width = DC.INT(100),
				height = DC.INT(100)
			}
		),
		img_id = DC.INT(0)
	}
) : __changed( function(conf)
	conf:TAB_SAVE()
end)


local fail_default = {
	["1"] = {
		id = 1,
		name = "oneScreen",
		number = "1",
		enable = 0,
		position = {
			{
				x = 0,
				y = 0,
				width = 100,
				height =100
			}
		},
		img_id = 0
	},
}

--------------------------------------------

function _M.Load()
	local conf = CONF.Create({}, layout_template)
	conf:TAB_STORAGE( "file", { file =  _M.config_file } )

	local _, r = conf:TAB_LOAD()
	if not r then --Try load a fail-default configure
		conf:TAB_BIND(fail_default or {})
		conf:TAB_SAVE()
	end
	conf:TAB_RESET_CHANGE()
	return conf
end

-------------------------------------------------------

return _M


