local DC = require "supertable.declare"
local CONF = require "supertable.core"

local _M = {
	config_file = "/data/configs/streamer.conf"
}

--------------------------------------------

local streamer_template = DC.SET(
	DC.OBJ{
		name = DC.STR(""),
		source_stream = DC.STR(""),
		streams = DC.SET(
			DC.OBJ{
				name = DC.STR(""),
				type = DC.STR("rtmp_push"),
				enable = DC.BOOL(false),

				address = DC.STR(""),
				auth = DC.BOOL(false),
				user = DC.STR(""),
				password = DC.STR(""),

				service_port = DC.INT(0),
				alter_port = DC.INT(0),

				video_port = DC.INT(0),
				audio_port = DC.INT(0),
				multicast = DC.BOOL(false),
				multicast_address = DC.STR(""),
				multicast_ttl = DC.INT(127)
			}
		)
	}
) : __changed( function(conf)
	conf:TAB_SAVE()
end)

--------------------------------------------

function _M.Load()
	local conf = CONF.Create({}, streamer_template)
	conf:TAB_STORAGE( "file", { file =  _M.config_file } )
	conf:TAB_LOAD()
	conf:TAB_RESET_CHANGE()
	return conf
end

-------------------------------------------------------

return _M


