------------------------------------------------------
-- AIBAO overlay application global initialzation.
------------------------------------------------------
require "himpp"

local SYS = HiMPP.SYS
local VB = HiMPP.VB

local _M = {}

-- Cleanup the MPP system.
function _M.Cleanup()
	SYS.Exit()
	local i
	for i=0, VB.MAX_USER-1 do
		VB.ExitModCommPool(i)
	end

	for i=0, VB.MAX_POOLS-1 do
		VB.DestroyPool(i)
	end

	VB.Exit()
end

-- Init the MPP system.
function _M.Init()
	SYS.Exit()
	VB.Exit()

	--First, setup the VB.
	local x, features = pcall(require, "features")
    if x and type(features) == "table" then
		if not features.FEATURE_MAX_RES_1080P then
			VB.Config(128, --Max pool count (?128)
			{
				{ u32BlkSize = 3840*2176*2, u32BlkCnt = 20 } --TODO: How large should this be?
			})
		else
			--翼多要支持用户模式,但不要支持4K解码输出
			if features.FEATURE_MAX_RES_1080P and features.DEV_BT1120_VI then
				VB.Config(128, --Max pool count (?128)
				{
					{ u32BlkSize = 1920*1088*2, u32BlkCnt = 20 }
				})
			else --HI3535既要支持用户模式,又要兼容解码内存问题 此处不要轻易改动
				VB.Config(128, --Max pool count (?128)
				{
					{ u32BlkSize = 1920*1088*3/2, u32BlkCnt = 8 }
				})
			end
		end
	else
		VB.Config( 128, --Max pool count (?128)
			{
				{ u32BlkSize = 1920*1088*2, u32BlkCnt = 0 }
			}
		)
	end
	
	VB.Init()
	SYS.Init()
end

return _M


