local _M = {
	--For capture:
	CAPTURE_VPSS_ID_BASE = 0,
	MAX_CAPTURE_CHANNELS = 2,
	
	--For decoder
	DECODER_VPSS_ID_BASE = 2,
	MAX_DECODER_CHANNELS = 16,

	--For stream decoder
	DECODER_CHANNEL_START = 3,
	--MAX_DECODER_CHANNELS = 16,

	--Create how many decoder groups (threads)
	CREATE_DECODER_GROUPS = 2,
	
	--Max output window grids.
	MAX_SUPPORT_WINDOWS = 16,

	--Max support encoders
	MAX_ENCODER_CHANNELS = 6,

	--Max audio output interfaces
	MAX_AOUT_CHANNELS = 3,

	--Max audio input interfaces.
	MAX_AIN_CHANNELS = 1,

	--For individual image preview decoder, if support.
	PREVIEW_IMG_DECODER_CHANNELS = {}, --Not used.

	--For JPEG preview image encoders.
	PREVIEW_IMG_ENCODER_CHANNELS = {1,2}, --Preview image encoders(JPEG)

	--Virtual screen (Aka. output Wbc) encoder.
	VIRTUAL_SCREEN_ENCODER_CHANNELS = {3,4}, --Virtual screen encoders

	--For local encoders (video input and encoding)
	LOCAL_ENCODER_CHANNELS = {} --Not used.
}

local soc_ain = require "soc.ain"
local soc_aout = require "soc.aout"
local soc_capture = require "soc.capture"
local soc_encoder = require "soc.encoder"
local soc_decoder = require "soc.decoder"

soc_ain.MAX_CHANNELS = _M.MAX_AIN_CHANNELS
soc_aout.MAX_CHANNELS = _M.MAX_AOUT_CHANNELS

soc_capture.VPSS_ID_BASE = _M.CAPTURE_VPSS_ID_BASE
soc_capture.MAX_CHANNELS = _M.MAX_CAPTURE_CHANNELS

soc_encoder.MAX_CHANNELS = _M.MAX_ENCODER_CHANNELS

soc_decoder.VPSS_ID_BASE = _M.DECODER_VPSS_ID_BASE
soc_decoder.MAX_CHANNELS = _M.MAX_DECODER_CHANNELS

return _M

