local _done, features = pcall(require, "features")
if not _done then
	features = {}
elseif type(features) ~= "table" then
	features = _G
end

local _M = {
	inputs = {
		--TODO:
	},

	outputs = {
		enabled_interfaces = {
			["HDMI"] = "HDMI",
			["BT1120"] = "SDI",
			["VGA"] = false,
			["CVBS"] = false,
			["NET"] = false
		},

		hd0_disabled_interfaces = {},
		hd1_disabled_interfaces = {}, --{ "HDMI" },
		sd0_disabled_interfaces = { "HDMI", "BT1120", "VGA", "NET" },

		hd0_default_bind = { video = { "HDMI" }, audio = { "HDMI" }, virtual_mixer = { "VS0" } },
		hd1_default_bind = { video = { "BT1120" }, audio = { "SDI" }, virtual_mixer = { "VS1" } },
		sd0_default_bind = { video = { "CVBS" }, audio = {} },

		--All interface(s) should bind at:
		common_audio_bind = { "LINEOUT" },

		hd0_default_layout = { "1", "2", "4", "9" },
		hd1_default_layout = { "1", "2", "4", "9" },

		audio_mapping = {
			["HDMI"] = "HDMI",
			["SDI"] = "SDI",
			["BT1120"] = "SDI",
			["LINEOUT"] = "LINEOUT",
		},
	}
}

if features.FEATURE_IPStream then
	_M.outputs.enabled_interfaces.NET = "IP Stream"
end

return _M

