local DC = require "supertable.declare"
local CONF = require "supertable.core"

local _M = {
	config_file = "/data/configs/ui.conf"
}
--------------------------------------------------------

local ui_template = DC.OBJ({
	channels = DC.ARR( 
		DC.OBJ({
			signal_type = DC.INT(0) : __changed( function(cfg,key)
				local id = tonumber(cfg.__proto.name)
				local svc = require "ui_service"
				svc.ChangeAlarmPolarity(id, cfg.signal_type)
			end),

			trigger = DC.STR("1+2"),
			priority = DC.INT(1),
			interval = DC.NUM(0.5)
		})
	)
}) : __changed( function(conf)
	conf:TAB_SAVE()
end)

-------------------------------------------------------
local failDefault = {
	channels = {
	[1] = {},
	[2] = {signal_type=1, trigger="2"}
	}
}
-------------------------------------------------------
function _M.Load()
	local conf = CONF.Create({}, ui_template)
	conf:TAB_STORAGE( "file", { file = _M.config_file } )
	local _, r = conf:TAB_LOAD()
	if not r then --Try load a fail-default configure
		conf:TAB_BIND( failDefault )
	end
	conf:TAB_RESET_CHANGE()
	return conf
end

-------------------------------------------------------

return _M


