local coaf = require "coaf.core"
local _dbg = require "coaf.debug"
local client = require "coaf.client"

local LED = require "ui_leds"
local SW = require "ui_switchs"

local _M = {
}

local function restoreCallback()
	-- LED.Force( "beep", {2,2}, 4 )
	if not testing then
		local cli = client.New( "systemctrl" )
		if cli then
			local proxy = cli:CreateProxy( "/", true )	--exclusive.
			if proxy then
				proxy.RestoreFactory()
				proxy:Destroy()
			end
			cli:Destroy()
		end
	end
end



function _M.Init()
	LED.Init()
	SW.Init()

	
	LED.CreateLight( "run", { --GPIO6_7
		muxreg = 0x120f012c,
		muxval = 0x01,
		pingroup = 0x121b0000,
		pin = 7
	})

	LED.CreateLight( "link", { --GPIO6_6
		muxreg = 0x120f0128,
		muxval = 0x01,
		pingroup = 0x121b0000,
		pin = 6
	})
	
	SW.CreateSW( "restore", { --GPIO0_0
		muxreg = 0x120f0148,
		muxval = 0,
		pingroup = 0x12150000,
		pin = 0,
		holdTimes = 24,
		callback = restoreCallback
	})
end

function _M.EnterResetStatus()
	LED.Force( "link", LED.BLINK_VERYFAST )
	LED.Force( "run", LED.BLINK_VERYFAST )
end

function _M.EnterRestoreStatus()
	LED.Force( "link", LED.BLINK_VERYFAST )
	LED.Force( "run", LED.BLINK_VERYFAST )
end

function _M.NormalStatus()
	LED.NoForce( "run" )
	LED.NoForce( "link" )
end

function _M.ForceLED( led, status, offAfter )
	if type(status) == "string" then
		LED.Force( led, LED[status] or LED.OFF, offAfter )
	else
		LED.Force( led, status, offAfter )
	end
end

function _M.SetLED( led, status, offAfter )
	if type(status) == "string" then
		LED.SetLightStatus( led, LED[status] or LED.OFF, offAfter )
	else
		LED.SetLightStatus( led, status, offAfter )
	end
end

return _M

