#!/usr/bin/env lua

local new_vercode = nil
local firmware_exist = false
local file = io.open( "/etc/fpga/VERSION", "r" )
if file then
	local line = file:read( "*l" )
	file:close()
	if line then
		new_vercode = tonumber( "0x" .. line )
	end
end

file = io.open( "/etc/fpga/firmware.bin", "rb" )
if file then
	firmware_exist = true
	file:close()
end

if new_vercode and firmware_exist then
	local hwchk = require "system.hardwareVersion"
	local ret = hwchk.ReadReg( 0xf0, {0x00} )
	if not ret or ret[1] < new_vercode then
		if ret and ret[1] > 0 and ret[1] <= 0xd0 then
			print( "*** Upgrading FPGA: The FPGA is not upgradable since with version code:", string.format("%02X", ret[1]) )
		else
			os.execute( "/usr/local/bin/progfpga.lua /etc/fpga/firmware.bin" )
		end
	else
		print( "*** Upgrading FPGA: The FPGA version is newest." )
	end
end

os.exit(0)

