#!/bin/sh

kernel_ver=`/bin/uname -r`
DONT_REBOOT=

if /usr/bin/test "$1" = "--no-reboot" ; then
	DONT_REBOOT=y
	shift
fi

LOC=/data/update
if /usr/bin/test "$1" != "" ; then
	LOC="$1"
fi

if ! /usr/bin/test -d $LOC; then
	/bin/mkdir -p $LOC
fi

upgrade_did="no"
action_code=1

if /usr/bin/test -f $LOC/upgrade.sh; then
	upgrade_did="yes"
	/bin/chmod +x $LOC/upgrade.sh
	cd $LOC
	$LOC/upgrade.sh $LOC
	action_code=$?
elif /usr/bin/test -f $LOC/upgrade.lua; then
	upgrade_did="yes"
	cd $LOC
	/usr/bin/lua $LOC/upgrade.lua -e UPDATE_LOC=\"$LOC\"
	action_code=$?
else
	/bin/rm $LOC/* -Rf	#Drop all files no used.
fi

RET_CODE=0

if /usr/bin/test "$upgrade_did" = "yes"; then
	if /usr/bin/test $action_code -eq 0; then
		/bin/rm $LOC/* -Rf
	elif /usr/bin/test $action_code -eq 1; then
		/bin/rm $LOC/* -Rf
		if /usr/bin/test "$DONT_REBOOT" = "y"; then
			RET_CODE=9
		else	
			/sbin/reboot
		fi
	elif /usr/bin/test $action_code -eq 2; then #No remove all files, but reboot
		if /usr/bin/test "$DONT_REBOOT" = "y"; then
			RET_CODE=9
		else	
			/sbin/reboot
		fi
	else
		/bin/rm $LOC/* -Rf
		if /usr/bin/test "$DONT_REBOOT" = "y"; then
			RET_CODE=9
		else	
			/sbin/reboot
		fi
	fi
fi

exit $RET_CODE

