local _M = {}

local ids_dict = {}
local MAX_ID = 1

function _M.Init()
    _G.cfg_roles = require "roles_config".Load()
    for _, v in pairs(_G.cfg_roles) do
        MAX_ID = math.max(v.id, MAX_ID)
        ids_dict[v.id] = true
    end
end

function _M.Add(data)
    if _G.cfg_roles[data.alias] then
        return false, "重复的角色名！"
    end

    local newId
    for i = 1, MAX_ID do
        if not ids_dict[i] then
            newId = i
            break
        end
    end

    if not newId then
        MAX_ID = MAX_ID + 1
        newId = MAX_ID
        ids_dict[newId] = true
    end

    _G.cfg_roles[data.alias] = {id = newId}
    for k, v in pairs(data) do
        _G.cfg_roles[data.alias][k] = v
    end

    _G.cfg_roles:__TRIGGER()
    return true
end

function _M.Get(name)
    if name then
        return _G.cfg_roles[name]
    end
    return _G.cfg_roles
end

function _M.Remove(ids)
    if type(ids) ~= "table" then
        ids = {ids}
    end
    
    for _, id in ipairs(ids) do
        id = tonumber(id)
        if id and id ~= 1 then
            for k, v in pairs(_G.cfg_roles) do
                if tonumber(v.id) == id then
                    _G.cfg_roles[k] = nil
                    local auth = require "sysctrl_auth"
                    auth.UpdateRole(k)
                    _G.cfg_roles:__TRIGGER()
                    break
                end
            end
        end
    end
    return true
end

function _M.Modify(data)
    local item = _G.cfg_roles[data.alias]
    if not item then
        return false, "Invalid role"
    end

    data.id = nil
    for k, v in pairs(data) do
        item[k] = v
    end

    _G.cfg_roles:__TRIGGER()
    return true
end

return _M